﻿using AppLauncher.Models;
using RyzStudio.Windows.ThemedForms;
using System;
using System.Drawing;

namespace AppLauncher.Windows.Forms
{
    public class AddTileForm : TDialogForm
    {
        public static void ShowDialog(TTilePanelLayout control, Point coord)
        {
            AddTileForm form = new AddTileForm();
            form.TilePanelLayout = control;
            form.AimCoord = coord;
            form.ShowDialog();
        }

        public static void ShowDialog(TListBox control)
        {
            AddTileForm form = new AddTileForm();
            form.ListBox = control;
            form.ShowDialog();
        }

        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.Label label7;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label1;
        private TOpenFileTextBox textBox2;
        private TTextBox textBox3;
        private TFolderTextBox textBox4;
        private TButton button1;
        private TPickerBox pickerBox1;
        private TPickerBox pickerBox2;
        private RyzStudio.Windows.Forms.THorizontalSeparator horizontalSeparator1;
        private RyzStudio.Windows.Forms.THorizontalSeparator horizontalSeparator2;
        private TTextBox textBox1;

        public TTilePanelLayout TilePanelLayout { get; set; } = null;
        public Point AimCoord { get; set; } = new Point(-1, -1);
        public TListBox ListBox { get; set; } = null;

        public AddTileForm() : base()
        {
            InitializeComponent();

            pickerBox1.ComboBox.Items.Clear();
            pickerBox1.ComboBox.Items.AddRange(new string[] { "Normal", "Hidden", "Minimized", "Maximized" });
            if (pickerBox1.ComboBox.Items.Count > 0) pickerBox1.ComboBox.SelectedIndex = 0;

            pickerBox2.ComboBox.Items.Clear();
            pickerBox2.ComboBox.Items.AddRange(new string[] { "No", "Yes" });
            if (pickerBox2.ComboBox.Items.Count > 0) pickerBox2.ComboBox.SelectedIndex = 0;
        }

        private void InitializeComponent()
        {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddTileForm));
            RyzStudio.Windows.ThemedForms.TButton.ButtonStyle buttonStyle1 = new RyzStudio.Windows.ThemedForms.TButton.ButtonStyle();
            RyzStudio.Windows.ThemedForms.TButton.ButtonStyle buttonStyle2 = new RyzStudio.Windows.ThemedForms.TButton.ButtonStyle();
            RyzStudio.Windows.ThemedForms.TButton.ButtonStyle buttonStyle3 = new RyzStudio.Windows.ThemedForms.TButton.ButtonStyle();
            this.textBox1 = new RyzStudio.Windows.ThemedForms.TTextBox();
            this.label6 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.textBox2 = new RyzStudio.Windows.ThemedForms.TOpenFileTextBox();
            this.textBox3 = new RyzStudio.Windows.ThemedForms.TTextBox();
            this.textBox4 = new RyzStudio.Windows.ThemedForms.TFolderTextBox();
            this.button1 = new RyzStudio.Windows.ThemedForms.TButton();
            this.pickerBox1 = new RyzStudio.Windows.ThemedForms.TPickerBox();
            this.pickerBox2 = new RyzStudio.Windows.ThemedForms.TPickerBox();
            this.horizontalSeparator1 = new RyzStudio.Windows.Forms.THorizontalSeparator();
            this.horizontalSeparator2 = new RyzStudio.Windows.Forms.THorizontalSeparator();
            ((System.ComponentModel.ISupportInitialize)(this.imgbxClose)).BeginInit();
            this.SuspendLayout();
            //
            // imgbxClose
            //
            this.imgbxClose.Image = ((System.Drawing.Image)(resources.GetObject("imgbxClose.Image")));
            this.imgbxClose.Location = new System.Drawing.Point(367, 5);
            //
            this.Text = "Add Tile";
            //
            // panel1
            //
            this.panel1.Location = new System.Drawing.Point(394, 474);
            //
            // area1
            //
            this.area1.Location = new System.Drawing.Point(1, 474);
            this.area1.Size = new System.Drawing.Size(392, 5);
            //
            // textBox1
            //
            this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox1.BackColor = System.Drawing.Color.Transparent;
            this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.textBox1.Location = new System.Drawing.Point(159, 50);
            this.textBox1.Margin = new System.Windows.Forms.Padding(10, 6, 10, 6);
            this.textBox1.Name = "textBox1";
            this.textBox1.Padding = new System.Windows.Forms.Padding(10, 10, 9, 9);
            this.textBox1.Size = new System.Drawing.Size(220, 32);
            this.textBox1.SubmitButton = null;
            this.textBox1.TabIndex = 152;
            this.textBox1.UseSystemPasswordChar = false;
            //
            // label6
            //
            this.label6.BackColor = System.Drawing.Color.Transparent;
            this.label6.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(95)))), ((int)(((byte)(99)))), ((int)(((byte)(104)))));
            this.label6.Location = new System.Drawing.Point(18, 268);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(208, 32);
            this.label6.TabIndex = 163;
            this.label6.Text = "Run As Admin";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            //
            // label7
            //
            this.label7.BackColor = System.Drawing.Color.Transparent;
            this.label7.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(95)))), ((int)(((byte)(99)))), ((int)(((byte)(104)))));
            this.label7.Location = new System.Drawing.Point(18, 227);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(208, 32);
            this.label7.TabIndex = 161;
            this.label7.Text = "Window Style";
            this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            //
            // label4
            //
            this.label4.BackColor = System.Drawing.Color.Transparent;
            this.label4.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(95)))), ((int)(((byte)(99)))), ((int)(((byte)(104)))));
            this.label4.Location = new System.Drawing.Point(18, 173);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(131, 32);
            this.label4.TabIndex = 159;
            this.label4.Text = "Working Directory";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            //
            // label3
            //
            this.label3.BackColor = System.Drawing.Color.Transparent;
            this.label3.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(95)))), ((int)(((byte)(99)))), ((int)(((byte)(104)))));
            this.label3.Location = new System.Drawing.Point(18, 132);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(131, 32);
            this.label3.TabIndex = 157;
            this.label3.Text = "Argument";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            //
            // label2
            //
            this.label2.BackColor = System.Drawing.Color.Transparent;
            this.label2.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(95)))), ((int)(((byte)(99)))), ((int)(((byte)(104)))));
            this.label2.Location = new System.Drawing.Point(18, 91);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(131, 32);
            this.label2.TabIndex = 155;
            this.label2.Text = "Filename";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            //
            // label1
            //
            this.label1.BackColor = System.Drawing.Color.Transparent;
            this.label1.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(95)))), ((int)(((byte)(99)))), ((int)(((byte)(104)))));
            this.label1.Location = new System.Drawing.Point(18, 50);
            this.label1.Margin = new System.Windows.Forms.Padding(0);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(131, 32);
            this.label1.TabIndex = 153;
            this.label1.Text = "Title";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            //
            // textBox2
            //
            this.textBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox2.BackColor = System.Drawing.Color.Transparent;
            this.textBox2.FileDialog = null;
            this.textBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.textBox2.HighlightImage = ((System.Drawing.Image)(resources.GetObject("textBox2.HighlightImage")));
            this.textBox2.Location = new System.Drawing.Point(159, 91);
            this.textBox2.Margin = new System.Windows.Forms.Padding(10, 3, 3, 3);
            this.textBox2.Name = "textBox2";
            this.textBox2.NormalImage = ((System.Drawing.Image)(resources.GetObject("textBox2.NormalImage")));
            this.textBox2.Padding = new System.Windows.Forms.Padding(10, 10, 9, 9);
            this.textBox2.Size = new System.Drawing.Size(220, 32);
            this.textBox2.SubmitButton = null;
            this.textBox2.TabIndex = 170;
            this.textBox2.UseSystemPasswordChar = false;
            //
            // textBox3
            //
            this.textBox3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox3.BackColor = System.Drawing.Color.Transparent;
            this.textBox3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.textBox3.Location = new System.Drawing.Point(159, 132);
            this.textBox3.Margin = new System.Windows.Forms.Padding(10, 6, 10, 6);
            this.textBox3.Name = "textBox3";
            this.textBox3.Padding = new System.Windows.Forms.Padding(10, 10, 9, 9);
            this.textBox3.Size = new System.Drawing.Size(220, 32);
            this.textBox3.SubmitButton = null;
            this.textBox3.TabIndex = 171;
            this.textBox3.UseSystemPasswordChar = false;
            //
            // textBox4
            //
            this.textBox4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.textBox4.BackColor = System.Drawing.Color.Transparent;
            this.textBox4.FolderDialog = null;
            this.textBox4.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.textBox4.HighlightImage = ((System.Drawing.Image)(resources.GetObject("textBox4.HighlightImage")));
            this.textBox4.Location = new System.Drawing.Point(159, 173);
            this.textBox4.Margin = new System.Windows.Forms.Padding(10, 3, 3, 3);
            this.textBox4.Name = "textBox4";
            this.textBox4.NormalImage = ((System.Drawing.Image)(resources.GetObject("textBox4.NormalImage")));
            this.textBox4.Padding = new System.Windows.Forms.Padding(10, 10, 9, 9);
            this.textBox4.Size = new System.Drawing.Size(220, 32);
            this.textBox4.SubmitButton = null;
            this.textBox4.TabIndex = 172;
            this.textBox4.UseSystemPasswordChar = false;
            //
            // button1
            //
            this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.button1.BackColor = System.Drawing.Color.Transparent;
            this.button1.DefaultImage = null;
            this.button1.DownImage = null;
            this.button1.LabelText = "&Save";
            this.button1.Location = new System.Drawing.Point(251, 427);
            this.button1.Name = "button1";
            this.button1.OverImage = null;
            this.button1.Padding = new System.Windows.Forms.Padding(4, 4, 3, 3);
            this.button1.Size = new System.Drawing.Size(128, 32);
            buttonStyle1.BackColour = System.Drawing.Color.White;
            buttonStyle1.ForeImage = null;
            buttonStyle1.PenColour = System.Drawing.Color.Black;
            this.button1.StyleDefault = buttonStyle1;
            buttonStyle2.BackColour = System.Drawing.Color.FromArgb(((int)(((byte)(179)))), ((int)(((byte)(179)))), ((int)(((byte)(179)))));
            buttonStyle2.ForeImage = null;
            buttonStyle2.PenColour = System.Drawing.Color.Black;
            this.button1.StyleDown = buttonStyle2;
            buttonStyle3.BackColour = System.Drawing.Color.FromArgb(((int)(((byte)(51)))), ((int)(((byte)(51)))), ((int)(((byte)(51)))));
            buttonStyle3.ForeImage = null;
            buttonStyle3.PenColour = System.Drawing.Color.White;
            this.button1.StyleOver = buttonStyle3;
            this.button1.TabIndex = 173;
            this.button1.Click += new System.EventHandler(this.button1_Click);
            //
            // pickerBox1
            //
            this.pickerBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.pickerBox1.BackColor = System.Drawing.Color.Transparent;
            this.pickerBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.pickerBox1.Location = new System.Drawing.Point(239, 227);
            this.pickerBox1.Margin = new System.Windows.Forms.Padding(10, 6, 10, 6);
            this.pickerBox1.Name = "pickerBox1";
            this.pickerBox1.Padding = new System.Windows.Forms.Padding(10, 6, 7, 5);
            this.pickerBox1.Size = new System.Drawing.Size(140, 32);
            this.pickerBox1.SubmitButton = null;
            this.pickerBox1.TabIndex = 174;
            //
            // pickerBox2
            //
            this.pickerBox2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.pickerBox2.BackColor = System.Drawing.Color.Transparent;
            this.pickerBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.pickerBox2.Location = new System.Drawing.Point(239, 268);
            this.pickerBox2.Margin = new System.Windows.Forms.Padding(10, 6, 10, 6);
            this.pickerBox2.Name = "pickerBox2";
            this.pickerBox2.Padding = new System.Windows.Forms.Padding(10, 6, 7, 5);
            this.pickerBox2.Size = new System.Drawing.Size(140, 32);
            this.pickerBox2.SubmitButton = null;
            this.pickerBox2.TabIndex = 175;
            //
            // horizontalSeparator1
            //
            this.horizontalSeparator1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.horizontalSeparator1.Location = new System.Drawing.Point(10, 215);
            this.horizontalSeparator1.MaximumSize = new System.Drawing.Size(4920, 2);
            this.horizontalSeparator1.Name = "horizontalSeparator1";
            this.horizontalSeparator1.Size = new System.Drawing.Size(380, 2);
            this.horizontalSeparator1.TabIndex = 176;
            //
            // horizontalSeparator2
            //
            this.horizontalSeparator2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
            | System.Windows.Forms.AnchorStyles.Right)));
            this.horizontalSeparator2.Location = new System.Drawing.Point(10, 310);
            this.horizontalSeparator2.MaximumSize = new System.Drawing.Size(4920, 2);
            this.horizontalSeparator2.Name = "horizontalSeparator2";
            this.horizontalSeparator2.Size = new System.Drawing.Size(380, 2);
            this.horizontalSeparator2.TabIndex = 177;
            //
            // AddTileForm
            //
            this.ClientSize = new System.Drawing.Size(400, 480);
            this.Controls.Add(this.horizontalSeparator2);
            this.Controls.Add(this.horizontalSeparator1);
            this.Controls.Add(this.pickerBox2);
            this.Controls.Add(this.pickerBox1);
            this.Controls.Add(this.button1);
            this.Controls.Add(this.textBox4);
            this.Controls.Add(this.textBox3);
            this.Controls.Add(this.textBox2);
            this.Controls.Add(this.label6);
            this.Controls.Add(this.label7);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.textBox1);
            this.Title = "Add Tile";
            this.Name = "AddTileForm";
            this.Controls.SetChildIndex(this.imgbxClose, 0);
            this.Controls.SetChildIndex(this.panel1, 0);
            this.Controls.SetChildIndex(this.area1, 0);
            this.Controls.SetChildIndex(this.textBox1, 0);
            this.Controls.SetChildIndex(this.label1, 0);
            this.Controls.SetChildIndex(this.label2, 0);
            this.Controls.SetChildIndex(this.label3, 0);
            this.Controls.SetChildIndex(this.label4, 0);
            this.Controls.SetChildIndex(this.label7, 0);
            this.Controls.SetChildIndex(this.label6, 0);
            this.Controls.SetChildIndex(this.textBox2, 0);
            this.Controls.SetChildIndex(this.textBox3, 0);
            this.Controls.SetChildIndex(this.textBox4, 0);
            this.Controls.SetChildIndex(this.button1, 0);
            this.Controls.SetChildIndex(this.pickerBox1, 0);
            this.Controls.SetChildIndex(this.pickerBox2, 0);
            this.Controls.SetChildIndex(this.horizontalSeparator1, 0);
            this.Controls.SetChildIndex(this.horizontalSeparator2, 0);
            ((System.ComponentModel.ISupportInitialize)(this.imgbxClose)).EndInit();
            this.ResumeLayout(false);

        }

        private void button1_Click(object sender, EventArgs e)
        {
            TileModel model = buildModel();

            if (this.TilePanelLayout != null)
            {
                this.TilePanelLayout.AddTile(model);
            }
            else if (this.ListBox != null)
            {
                int n = this.ListBox.ListBox.Items.Add(model);
                this.ListBox.ListBox.SelectedIndex = n;
            }

            this.Close();
        }

        protected TileModel buildModel()
        {
            TileModel rs = new TileModel()
            {
                Title = textBox1.Text?.Trim(),
                ProcessFilename = textBox2.Text?.Trim(),
                ProcessArgument = textBox3.Text?.Trim(),
                ProcessWorkingDirectory = textBox4.Text?.Trim(),
                ProcessWindowStyle = (System.Diagnostics.ProcessWindowStyle)pickerBox1.ComboBox.SelectedIndex,
                ProcessAsAdmin = (pickerBox2.ComboBox.SelectedIndex == 1)
            };

            if (!this.AimCoord.Equals(new Point(-1, -1)))
            {
                rs.Position = this.AimCoord;
            }

            return rs;
        }

    }
}
